// Generated by CoffeeScript 1.6.3
(function() {
  var Bottleneck,
    __slice = [].slice;

  Bottleneck = (function() {
    function Bottleneck(maxNb, minTime) {
      this.maxNb = maxNb != null ? maxNb : 0;
      this.minTime = minTime != null ? minTime : 0;
      this.nextRequest = Date.now();
      this.nbRunning = 0;
      this.queue = [];
      this.timeouts = [];
    }

    Bottleneck.prototype._tryToRun = function() {
      var done, next, wait,
        _this = this;
      if ((this.nbRunning < this.maxNb || this.maxNb <= 0) && this.queue.length > 0) {
        this.nbRunning++;
        wait = Math.max(this.nextRequest - Date.now(), 0);
        this.nextRequest = Date.now() + wait + this.minTime;
        next = this.queue.shift();
        done = false;
        return this.timeouts.push(setTimeout(function() {
          return next.task.apply({}, next.args.concat(function() {
            if (!done) {
              done = true;
              _this.nbRunning--;
              _this._tryToRun();
              return next.cb.apply({}, Array.prototype.slice.call(arguments, 0));
            }
          }));
        }, wait));
      }
    };

    Bottleneck.prototype.submit = function() {
      var args, cb, task, _i;
      task = arguments[0], args = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), cb = arguments[_i++];
      this.queue.push({
        task: task,
        args: args,
        cb: cb
      });
      return this._tryToRun();
    };

    Bottleneck.prototype.stopAll = function() {
      var a, _i, _len, _ref;
      _ref = this.timeouts;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        a = _ref[_i];
        clearTimeout(a);
      }
      return this._tryToRun = function() {};
    };

    return Bottleneck;

  })();

  module.exports = Bottleneck;

}).call(this);
